package eu.DECIDEh2020.architect.plugin.utils;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.eclipse.core.runtime.Status;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;

import eu.DECIDEh2020.appManager.models.Nfr;
import eu.DECIDEh2020.appManager.models.Pattern;
import eu.DECIDEh2020.architect.cloudpatterns.Patterns;
import eu.DECIDEh2020.architect.plugin.Activator;

public class CloudPatternHelper {

	public static ObjectNode getPattern(String uriRef) {
		return Patterns.createDefaultPatterns().getPatternAsJson(uriRef);
	}

	public static List<Pattern> inferPatterns(List<Nfr> nfrs) {
		if(nfrs == null || nfrs.isEmpty()) {
			return new ArrayList<>();
		}
		
		ObjectMapper mapper = new ObjectMapper();
		List<ObjectNode> patternNodes = Patterns.createDefaultPatterns().inferPatternsJson(nfrs.stream().map(nfr -> (ObjectNode)mapper.valueToTree(nfr)).collect(Collectors.toList()));

		List<Pattern> patterns = new ArrayList<>();
		patternNodes.forEach(pattern -> {
			try {
				patterns.add(mapper.treeToValue(pattern, Pattern.class));
			} catch (JsonProcessingException e) {
				Activator.getDefault().getLog().log(new Status(Status.ERROR, Activator.PLUGIN_ID, "Map pattern class.", e));
			}
		});
		return patterns;
	}
	
}
