/*
 * Copyright (c) 2017 Fraunhofer FOKUS.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the
 * GNU AGPL v3 which accompanies
 * this distribution, and is available at
 * http://www.gnu.org/licenses/agpl.txt
 *
 * Contributors:
 * Simon Dutkowski Fraunhofer FOKUS
 *
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 */
package eu.DECIDEh2020.architect.cloudpatterns;

import com.fasterxml.jackson.databind.node.ObjectNode;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.Resource;


import java.io.InputStream;
import java.util.List;

public interface Patterns {

    Model getModel();

    List<Resource> query(String queryString);

    List<Resource> listPatterns();

    List<ObjectNode> getPatternsByCategory(String type);

    List<Resource> getPatternsByCategory(Resource type);

    Resource getPattern(String uri);

    ObjectNode getPatternAsJson(String uri);

    Resource getNFR(String uri);

    InputStream getIcon(Resource icon);

    List<Resource> listNFRs();

    List<Resource> inferPatterns(List<Resource> nfrs);

    List<ObjectNode> inferPatternsJson(List<ObjectNode> nfrs);

    List<Resource> inferBadPatterns(List<Resource> nfrs);

    static Patterns createDefaultPatterns() {
        return new PatternsImpl();
    }

}
